Index: main.py
===================================================================
--- main.py	(revision 01445ecc4506e14ea22389344bc7a26f9f4b8ab3)
+++ main.py	(revision 2fd1c0a0864f2e7a78c00398672c3eaff10e2c6c)
@@ -1,3 +1,4 @@
 #!/usr/bin/python
+# -*- coding: utf-8 -*-
 
 import sys
@@ -18,6 +19,6 @@
 from logging.handlers import RotatingFileHandler
 logger = logging.getLogger('GPPDcockpit')
-hdlr = RotatingFileHandler(os.getcwd() + '/GPPDcockpit.log', maxBytes=100
-                           * 1024 * 1024, backupCount=1)
+hdlr = RotatingFileHandler(os.getcwd() + '/GPPDcockpit.log',
+                           maxBytes=100 * 1024 * 1024, backupCount=1)
 formatter = logging.Formatter('%(asctime)s %(levelname)s %(message)s')
 hdlr.setFormatter(formatter)
@@ -25,5 +26,5 @@
 logger.setLevel(logging.DEBUG)
 
-GPPDgroup1=[]
+GPPDgroup1 = []
 GPPDgroup1.append('module521')
 GPPDgroup1.append('module522')
@@ -36,5 +37,5 @@
 GPPDgroup1.append('module543')
 
-GPPDgroup2=[]
+GPPDgroup2 = []
 GPPDgroup2.append('module621')
 GPPDgroup2.append('module622')
@@ -47,5 +48,5 @@
 GPPDgroup2.append('module643')
 
-GPPDgroup3=[]
+GPPDgroup3 = []
 GPPDgroup3.append('module131')
 GPPDgroup3.append('module132')
@@ -69,14 +70,18 @@
 GPPDgroup3.append('module443')
 
-GPPDgroup4=[]
+GPPDgroup4 = []
 GPPDgroup4.append('monitor1')
 GPPDgroup4.append('monitor2')
 GPPDgroup4.append('monitor3')
 
-GPPDdrone=[]
-for _g in GPPDgroup1: GPPDdrone.append(_g)
-for _g in GPPDgroup2: GPPDdrone.append(_g)
-for _g in GPPDgroup3: GPPDdrone.append(_g)
-for _g in GPPDgroup4: GPPDdrone.append(_g)
+GPPDdrone = []
+for _g in GPPDgroup1:
+    GPPDdrone.append(_g)
+for _g in GPPDgroup2:
+    GPPDdrone.append(_g)
+for _g in GPPDgroup3:
+    GPPDdrone.append(_g)
+for _g in GPPDgroup4:
+    GPPDdrone.append(_g)
 webInfo = {}
 _group = ['pilot', 'mantid']
@@ -107,58 +112,66 @@
     webInfo[_g]['level'] = '---'
 
-droneInfo=[]
-_n=-1
+droneInfo = []
+_n = -1
 
 # left backward
+
 for i in range(len(GPPDgroup1)):
-    _n+=1
+    _n += 1
     droneInfo.append({})
-    droneInfo[_n]['host']='10.1.33.144'
-    droneInfo[_n]['module']=GPPDgroup1[i]
-    droneInfo[_n]['pid']='---'
-    droneInfo[_n]['pobox']='---'
-    droneInfo[_n]['rpc']='---'
+    droneInfo[_n]['host'] = '10.1.33.144'
+    droneInfo[_n]['module'] = GPPDgroup1[i]
+    droneInfo[_n]['pid'] = '---'
+    droneInfo[_n]['pobox'] = '---'
+    droneInfo[_n]['rpc'] = '---'
     droneInfo[_n]['state'] = 'waiting'
     droneInfo[_n]['timestamp'] = '---'
-    droneInfo[_n]['heartbeat']='/GPPD/heartbeat/detector/'+GPPDgroup1[i]
+    droneInfo[_n]['heartbeat'] = '/GPPD/heartbeat/detector/' \
+        + GPPDgroup1[i]
 
 # right backward
+
 for i in range(len(GPPDgroup2)):
-    _n+=1
+    _n += 1
     droneInfo.append({})
-    droneInfo[_n]['host']='10.1.33.144'
-    droneInfo[_n]['module']=GPPDgroup2[i]
-    droneInfo[_n]['pid']='---'
-    droneInfo[_n]['pobox']='---'
-    droneInfo[_n]['rpc']='---'
-    droneInfo[_n]['state'] = 'waiting'
-    droneInfo[_n]['timestamp'] = '---'    
-    droneInfo[_n]['heartbeat']='/GPPD/heartbeat/detector/'+GPPDgroup2[i]
-
-#small angle
-for i in range(len(GPPDgroup3)):
-    _n+=1
-    droneInfo.append({})
-    droneInfo[_n]['host']='10.1.33.144'
-    droneInfo[_n]['module']=GPPDgroup3[i]
-    droneInfo[_n]['pid']='---'
-    droneInfo[_n]['pobox']='---'
-    droneInfo[_n]['rpc']='---'
+    droneInfo[_n]['host'] = '10.1.33.144'
+    droneInfo[_n]['module'] = GPPDgroup2[i]
+    droneInfo[_n]['pid'] = '---'
+    droneInfo[_n]['pobox'] = '---'
+    droneInfo[_n]['rpc'] = '---'
     droneInfo[_n]['state'] = 'waiting'
     droneInfo[_n]['timestamp'] = '---'
-    droneInfo[_n]['heartbeat']='/GPPD/heartbeat/detector/'+GPPDgroup3[i]
-
-#monitor
-for i in range(len(GPPDgroup4)):
-    _n+=1
+    droneInfo[_n]['heartbeat'] = '/GPPD/heartbeat/detector/' \
+        + GPPDgroup2[i]
+
+# small angle
+
+for i in range(len(GPPDgroup3)):
+    _n += 1
     droneInfo.append({})
-    droneInfo[_n]['host']='10.1.33.144'
-    droneInfo[_n]['module']=GPPDgroup4[i]
-    droneInfo[_n]['pid']='---'
-    droneInfo[_n]['pobox']='---'
-    droneInfo[_n]['rpc']='---'
+    droneInfo[_n]['host'] = '10.1.33.144'
+    droneInfo[_n]['module'] = GPPDgroup3[i]
+    droneInfo[_n]['pid'] = '---'
+    droneInfo[_n]['pobox'] = '---'
+    droneInfo[_n]['rpc'] = '---'
     droneInfo[_n]['state'] = 'waiting'
     droneInfo[_n]['timestamp'] = '---'
-    droneInfo[_n]['heartbeat']='/GPPD/heartbeat/detector/'+GPPDgroup4[i]
+    droneInfo[_n]['heartbeat'] = '/GPPD/heartbeat/detector/' \
+        + GPPDgroup3[i]
+
+# monitor
+
+for i in range(len(GPPDgroup4)):
+    _n += 1
+    droneInfo.append({})
+    droneInfo[_n]['host'] = '10.1.33.144'
+    droneInfo[_n]['module'] = GPPDgroup4[i]
+    droneInfo[_n]['pid'] = '---'
+    droneInfo[_n]['pobox'] = '---'
+    droneInfo[_n]['rpc'] = '---'
+    droneInfo[_n]['state'] = 'waiting'
+    droneInfo[_n]['timestamp'] = '---'
+    droneInfo[_n]['heartbeat'] = '/GPPD/heartbeat/detector/' \
+        + GPPDgroup4[i]
 
 for i in range(len(droneInfo)):
@@ -173,5 +186,4 @@
     webInfo[_g]['level'] = '---'
 
-
 fh = 0
 
@@ -193,29 +205,31 @@
     # _cmd="ps -ef | grep "+myname+" | grep -v grep | awk '{print $2}'"
 
-    pid1=[]
-    pid2=[]
-
-    _s=False
+    pid1 = []
+    pid2 = []
+
+    _s = False
     try:
         _cmd = 'ps -C ' + myname + ' -o pid='
         pid1 = subprocess.check_output(_cmd, shell=True)
         pid1 = shlex.split(pid1)
-        _s=True
+        _s = True
     except:
-        pid1=[]
+        pid1 = []
 
     if not _s:
         try:
-            _tmp="\"python "+myname+"\""
-            _cmd = "ps -C " + _tmp + " -o pid="
+            _tmp = '"python ' + myname + '"'
+            _cmd = 'ps -C ' + _tmp + ' -o pid='
             pid2 = subprocess.check_output(_cmd, shell=True)
             pid2 = shlex.split(pid2)
         except:
-            pid2=[]
-    
-    pid=[]
-    for p in pid1:pid.append(p)
-    for p in pid2:pid.append(p)
-    
+            pid2 = []
+
+    pid = []
+    for p in pid1:
+        pid.append(p)
+    for p in pid2:
+        pid.append(p)
+
     for p in pid:
         if p != mypid:
@@ -266,4 +280,5 @@
     return time.strftime('%Y-%m-%d %H:%M:%S')
 
+
 class startRedisServer:
 
@@ -298,7 +313,8 @@
         return PID
 
-class getRedisServer():
-
-   def __init__(
+
+class getRedisServer:
+
+    def __init__(
         self,
         ip,
@@ -309,36 +325,42 @@
         from redis.sentinel import Sentinel
 
-        self.status=False
-        self.redisWrite=None
-        self.redisRead=None
-        begin=time.time()
+        self.status = False
+        self.redisWrite = None
+        self.redisRead = None
+        begin = time.time()
         while True:
             if self.redisWrite is None:
-                #self.server = redis.Redis(host=ip, port=port, password=passwd, db=0, socket_connect_timeout=1.0)
+
+                # self.server = redis.Redis(host=ip, port=port, password=passwd, db=0, socket_connect_timeout=1.0)
+
                 sentinel = Sentinel(ip, socket_timeout=0.1)
                 try:
-                    self.redisWrite=sentinel.master_for('neonmaster', socket_timeout=30, password=passwd)
-                    self.redisRead=sentinel.slave_for('neonmaster', socket_timeout=30, password=passwd)
-                except (redis.exceptions.ConnectionError):
-                    logger.error("Redis exception")
+                    self.redisWrite = sentinel.master_for('neonmaster',
+                            socket_timeout=30, password=passwd)
+                    self.redisRead = sentinel.slave_for('neonmaster',
+                            socket_timeout=30, password=passwd)
+                except redis.exceptions.ConnectionError:
+                    logger.error('Redis exception')
                 if self.redisWrite is not None:
-                    if self.redisRead is None: self.redisRead=self.redisWrite
+                    if self.redisRead is None:
+                        self.redisRead = self.redisWrite
                     self.status = True
-                    logger.info("Redis connected")
+                    logger.info('Redis connected')
                     break
                 else:
-                    logger.error("Redis falied")
-                if time.time()-begin>timeout:
-                    logger.warning("Reids timeout")
+                    logger.error('Redis falied')
+                if time.time() - begin > timeout:
+                    logger.warning('Reids timeout')
                     break
 
-   def getStatus(self):
+    def getStatus(self):
         return self.status
 
-   def getRedisWrite(self):
+    def getRedisWrite(self):
         return self.redisWrite
 
-   def getRedisRead(self):
+    def getRedisRead(self):
         return self.redisRead
+
 
 class getEpicsServer:
@@ -363,33 +385,47 @@
         return self.status
 
-class getDroneServer():
+
+class getDroneServer:
+
     def __init__(self):
-        ip=[('10.1.33.141', 9001)]
+        ip = [('10.1.33.141', 9001)]
 
         self.nModule = len(droneInfo)
 
-        self.m_neonRedis = NEON.Neon.NeonRedisSentinel(ip, i_socket_timeout=0.5, master_name='neonmaster', master_timeout = 60, master_password='sanlie;123', isWritable = True)
-       
+        self.m_neonRedis = NEON.Neon.NeonRedisSentinel(
+            ip,
+            i_socket_timeout=0.5,
+            master_name='neonmaster',
+            master_timeout=60,
+            master_password='sanlie;123',
+            isWritable=True,
+            )
+
         self.createAll()
 
     def create(self, n):
-        clitpob= NEON.Neon.NeonService.POBox(self.m_neonRedis, '/GPPD/process/detector', 'client:'+droneInfo[n]['module'])
-        clitrpc = NEON.Neon.NeonService.NeonRPC(sendPOBox = clitpob, recvPOBox = clitpob)
-        droneInfo[n]['pobox']=clitrpc
-        droneInfo[n]['rpc']='server:'+droneInfo[n]['module']
-        _pid=self.getPid(n)
+        clitpob = NEON.Neon.NeonService.POBox(self.m_neonRedis,
+                '/GPPD/process/detector', 'client:'
+                + droneInfo[n]['module'])
+        clitrpc = NEON.Neon.NeonService.NeonRPC(sendPOBox=clitpob,
+                recvPOBox=clitpob)
+        droneInfo[n]['pobox'] = clitrpc
+        droneInfo[n]['rpc'] = 'server:' + droneInfo[n]['module']
+        _pid = self.getPid(n)
 
         if _pid == -1:
             for i in range(5):
-                _cmd="ssh drone@"+droneInfo[n]['host']+" cd /home/drone/workspace/drone/ && ./"+droneInfo[n]['module']
+                _cmd = 'ssh drone@' + droneInfo[n]['host'] \
+                    + ' cd /home/drone/workspace/drone/ && ./' \
+                    + droneInfo[n]['module']
                 _cmd = shlex.split(_cmd)
                 subprocess.Popen(_cmd, shell=False)
                 time.sleep(1.0)
-                _pid=self.getPid(n)
-                if _pid !=-1:
-                    droneInfo[n]['pid']=str(_pid)
+                _pid = self.getPid(n)
+                if _pid != -1:
+                    droneInfo[n]['pid'] = str(_pid)
                     break
         else:
-            droneInfo[n]['pid']=str(_pid)
+            droneInfo[n]['pid'] = str(_pid)
 
         webInfo[droneInfo[n]['module']]['pid'] = str(droneInfo[n]['pid'
@@ -422,9 +458,11 @@
 
     def getPid(self, n):
-        _cmd="ssh drone@"+droneInfo[n]['host']+" ps -ef | grep "+droneInfo[n]['module']+".py | awk '{print $2}' | head -1"
+        _cmd = 'ssh drone@' + droneInfo[n]['host'] + ' ps -ef | grep ' \
+            + droneInfo[n]['module'] \
+            + ".py | awk '{print $2}' | head -1"
         print _cmd
-        pid=subprocess.check_output(_cmd, shell=True)
-        if pid!='':
-            pid=int(pid)
+        pid = subprocess.check_output(_cmd, shell=True)
+        if pid != '':
+            pid = int(pid)
         else:
             pid = -1
@@ -514,8 +552,10 @@
         self.killAll()
 
+
 class RPCMethods(NEON.Neon.NeonService.NeonRPC.MethodCall):
 
     def setDroneStatus(self, params):
         return True
+
 
 class setGlassfish(threading.Thread):
@@ -623,21 +663,20 @@
                 self.getDroneStatus(i)
 
-            self.redisServer.set('/GPPD/cockpit/web', json.dumps(webInfo))
+            self.redisServer.set('/GPPD/cockpit/web',
+                                 json.dumps(webInfo))
             time.sleep(self.refreshtime)
 
+
 class setHeartbeat(threading.Thread):
 
-    def __init__(
-        self,
-        refreshtime,
-        ):
+    def __init__(self, refreshtime):
+
         threading.Thread.__init__(self)
-        pvHeart = "EXP_IB1_RM:soft:analyse_hb"
-        self.pvname=epics.PV(pvHeart)
-        self.refreshtime=refreshtime
-
+        pvHeart = 'EXP_IB1_RM:soft:analyse_hb'
+        self.pvname = epics.PV(pvHeart)
+        self.refreshtime = refreshtime
 
     def setStatus(self, _status):
-        self.status=_status
+        self.status = _status
 
     def getStatus(self):
@@ -655,18 +694,17 @@
             time.sleep(self.refreshtime)
 
+
 class setStatus(threading.Thread):
 
-    def __init__(
-        self,
-        refreshtime,
-        ):
+    def __init__(self, refreshtime):
+
         threading.Thread.__init__(self)
 
-        self.status='WAITING'
+        self.status = 'WAITING'
         self.pvname = epics.PV('EXP_IB1_RM:soft:analyse_hb')
-        self.refreshtime=refreshtime
+        self.refreshtime = refreshtime
 
     def setStatus(self, _status):
-        self.status=_status
+        self.status = _status
 
     def getStatus(self):
@@ -681,5 +719,7 @@
             time.sleep(self.refreshtime)
 
+
 class main(threading.Thread):
+
     def __init__(self, redisServer, droneServer):
         threading.Thread.__init__(self)
@@ -690,5 +730,5 @@
         self.droneServer = droneServer
 
-        self.pvCommand=epics.PV('EXP_IB1_GP:soft:cmd')
+        self.pvCommand = epics.PV('EXP_IB1_GP:soft:cmd')
         self.pvStatus = epics.PV('EXP_IB1_GP:soft:online_stat')
 
@@ -696,18 +736,35 @@
         self.pvUserId = epics.PV('EXP_IB1_GP:soft:user_id')
         self.pvProposalId = epics.PV('EXP_IB1_GP:soft:proposal_id')
-        
-        self.GPPDstatusList=['INITIALIZED', 'READY', 'RUNNING']
-        self.GPPDcommandList=["CONF", "START", "STOP", "EXIT", "CANCEL"]
-        self.MYstatusList=["waiting", "unconfigured", "configuring", "ready", "running", "paused", "error"]
-        self.MYcommandList=["configure", "unconfigure", "start", "pause", "resume", "stop", "abort"]
-
-        self.mantidHeartBeat='/GPPD/heartbeat/mantid'
-        self.pilotHeartBeat='/GPPD/heartbeat/pilot'
+
+        self.GPPDstatusList = ['INITIALIZED', 'READY', 'RUNNING']
+        self.GPPDcommandList = ['CONF', 'START', 'STOP', 'EXIT',
+                                'CANCEL']
+        self.MYstatusList = [
+            'waiting',
+            'unconfigured',
+            'configuring',
+            'ready',
+            'running',
+            'paused',
+            'error',
+            ]
+        self.MYcommandList = [
+            'configure',
+            'unconfigure',
+            'start',
+            'pause',
+            'resume',
+            'stop',
+            'abort',
+            ]
+
+        self.mantidHeartBeat = '/GPPD/heartbeat/mantid'
+        self.pilotHeartBeat = '/GPPD/heartbeat/pilot'
 
         self.iRetry = 20
         self.lastTimeStamp = '---'
         self.lastCmd = -1
-        self.endType="time"
-        self.myState="unconfigured"
+        self.endType = 'time'
+        self.myState = 'unconfigured'
 
         self.setInitial()
@@ -716,5 +773,5 @@
         self.resetProtonChargeList()
         self.resetMonitorCountList()
-        self.resetDetectorCountList()    
+        self.resetDetectorCountList()
 
         try:
@@ -730,5 +787,5 @@
                     logger.error('mantid abort failed')
                     self.setEpicsState('ERROR')
-                    self.myState="error"
+                    self.myState = 'error'
                     self.stop.set()
             if int(self.getPilotStatus()[0]) != 1:
@@ -737,9 +794,9 @@
                     logger.error('pilot abort failed')
                     self.setEpicsState('ERROR')
-                    self.myState="error"
+                    self.myState = 'error'
                     self.stop.set()
 
             self.setEpicsState('INITIALIZED')
-            self.myState="unconfigured"
+            self.myState = 'unconfigured'
         elif _pvState == 'READY':
 
@@ -755,5 +812,5 @@
                         logger.error('mantid configure failed')
                         self.setEpicsState('ERROR')
-                        self.myState="error"
+                        self.myState = 'error'
                         self.stop.set()
                 else:
@@ -764,5 +821,5 @@
                         logger.error('mantid abort failed')
                         self.setEpicsState('ERROR')
-                        self.myState="error"
+                        self.myState = 'error'
                         self.stop.set()
 
@@ -774,5 +831,5 @@
                         logger.error('mantid configure failed')
                         self.setEpicsState('ERROR')
-                        self.myState="error"
+                        self.myState = 'error'
                         self.stop.set()
 
@@ -789,5 +846,5 @@
                         logger.error('pilot configure failed')
                         self.setEpicsState('ERROR')
-                        self.myState="error"
+                        self.myState = 'error'
                         self.stop.set()
                 else:
@@ -798,5 +855,5 @@
                         logger.error('pilot abort failed')
                         self.setEpicsState('ERROR')
-                        self.myState="error"
+                        self.myState = 'error'
                         self.stop.set()
 
@@ -808,9 +865,9 @@
                         logger.error('pilot configure failed')
                         self.setEpicsState('ERROR')
-                        self.myState="error"
+                        self.myState = 'error'
                         self.stop.set()
 
             self.setEpicsState('READY')
-            self.myState="ready"
+            self.myState = 'ready'
         elif _pvState == 'RUNNING':
             _r = self.getMantidStatus()
@@ -823,5 +880,5 @@
                         logger.error('mantid start failed')
                         self.setEpicsState('ERROR')
-                        self.myState="error"
+                        self.myState = 'error'
                         self.stop.set()
                 else:
@@ -831,5 +888,5 @@
                         logger.error('mantid abort failed')
                         self.setEpicsState('ERROR')
-                        self.myState="error"
+                        self.myState = 'error'
                         self.stop.set()
 
@@ -841,5 +898,5 @@
                         logger.error('mantid configure failed')
                         self.setEpicsState('ERROR')
-                        self.myState="error"
+                        self.myState = 'error'
                         self.stop.set()
 
@@ -849,5 +906,5 @@
                         logger.error('mantid start failed')
                         self.setEpicsState('ERROR')
-                        self.myState="error"
+                        self.myState = 'error'
                         self.stop.set()
 
@@ -861,5 +918,5 @@
                         logger.error('pilot start failed')
                         self.setEpicsState('ERROR')
-                        self.myState="error"
+                        self.myState = 'error'
                         self.stop.set()
                 else:
@@ -869,5 +926,5 @@
                         logger.error('pilot abort failed')
                         self.setEpicsState('ERROR')
-                        self.myState="error"
+                        self.myState = 'error'
                         self.stop.set()
 
@@ -879,5 +936,5 @@
                         logger.error('pilot configure failed')
                         self.setEpicsState('ERROR')
-                        self.myState="error"
+                        self.myState = 'error'
                         self.stop.set()
 
@@ -887,5 +944,5 @@
                         logger.error('pilot start failed')
                         self.setEpicsState('ERROR')
-                        self.myState="error"
+                        self.myState = 'error'
                         self.stop.set()
 
@@ -894,5 +951,5 @@
             self.getDetectorCount()
             self.setEpicsState('RUNNING')
-            self.myState="running"
+            self.myState = 'running'
         else:
 
@@ -903,5 +960,5 @@
 
             self.setEpicsState('INITIALIZED')
-            self.myState="unconfigured"
+            self.myState = 'unconfigured'
 
     def setEpicsState(self, _status):
@@ -982,5 +1039,5 @@
                              json.dumps(self.detectorCountList))
 
-        if _tmp !=0:
+        if _tmp != 0:
             try:
                 self.pvNeutron.put(_tmp)
@@ -1075,9 +1132,8 @@
                                  json.dumps(_tmp))
         else:
-            self.redisServer.set('/GPPD/drone/startTime', json.dumps('---'
-                                 ))
+            self.redisServer.set('/GPPD/drone/startTime',
+                                 json.dumps('---'))
             self.redisServer.set('/GPPD/drone/startTimeFloat',
                                  json.dumps(0))
-
 
     def setEndTime(self, now=True):
@@ -1086,9 +1142,11 @@
             _str = time.strftime('%Y-%m-%d %H:%M:%S',
                                  time.localtime(_tmp))
-            self.redisServer.set('/GPPD/drone/endTime', json.dumps(_str))
+            self.redisServer.set('/GPPD/drone/endTime',
+                                 json.dumps(_str))
             self.redisServer.set('/GPPD/drone/endTimeFloat',
                                  json.dumps(_tmp))
         else:
-            self.redisServer.set('/GPPD/drone/endTime', json.dumps('---'))
+            self.redisServer.set('/GPPD/drone/endTime', json.dumps('---'
+                                 ))
             self.redisServer.set('/GPPD/drone/endTimeFloat',
                                  json.dumps(0))
@@ -1101,4 +1159,5 @@
         retry,
         ):
+
         com = str(com)
         cmd = int(cmd)
@@ -1157,5 +1216,5 @@
         except:
             droneInfo[n]['state'] = 'error'
-    
+
     def getMantidStatus(self):
         try:
@@ -1204,6 +1263,6 @@
             proposalID = '---'
 
-        self.endType="time"
-        self.endValue=600.0
+        self.endType = 'time'
+        self.endValue = 600.0
 
         _configure = {}
@@ -1215,12 +1274,12 @@
         _configure['progressMax'] = 20.0
 
-        _configure=json.dumps(_configure, ensure_ascii=False)
-        self.redisServer.set("/GPPD/control/configure", _configure)
-        logger.info("Set configure, %d" % run_no)
+        _configure = json.dumps(_configure, ensure_ascii=False)
+        self.redisServer.set('/GPPD/control/configure', _configure)
+        logger.info('Set configure, %d' % run_no)
 
     def seekCommand(self, module, toState):
-        if module=="mantid":
+        if module == 'mantid':
             _r = self.getMantidStatus()
-        elif module=="pilot":
+        elif module == 'pilot':
             _r = self.getPilotStatus()
         else:
@@ -1234,12 +1293,12 @@
         if fromState == toState:
             pass
-        elif toState == "error":
+        elif toState == 'error':
             pass
         else:
-            if fromState == "unconfigured":
-                if toState == "ready":
+            if fromState == 'unconfigured':
+                if toState == 'ready':
                     _success = self.setCommand(module, 0, 3,
                             self.iRetry)
-                elif toState == "running":
+                elif toState == 'running':
                     _success = self.setCommand(module, 0, 3,
                             self.iRetry)
@@ -1248,20 +1307,20 @@
                 else:
                     pass
-            elif fromState == "ready":
-                if toState == "unconfigured":
+            elif fromState == 'ready':
+                if toState == 'unconfigured':
                     _success = self.setCommand(module, 1, 3,
                             self.iRetry)
-                elif toState == "running":
+                elif toState == 'running':
                     _success = self.setCommand(module, 2, 4,
                             self.iRetry)
                 else:
                     pass
-            elif fromState == "running":
-                if toState == "unconfigured":
+            elif fromState == 'running':
+                if toState == 'unconfigured':
                     _success = self.setCommand(module, 5, 3,
                             self.iRetry)
                     _success = self.setCommand(module, 1, 1,
                             self.iRetry)
-                elif toState == "ready":
+                elif toState == 'ready':
                     _success = self.setCommand(module, 5, 3,
                             self.iRetry)
@@ -1273,6 +1332,6 @@
     def run(self):
         while True:
-            self.seekCommand("mantid", self.myState)
-            self.seekCommand("pilot", self.myState)
+            self.seekCommand('mantid', self.myState)
+            self.seekCommand('pilot', self.myState)
 
             try:
@@ -1285,5 +1344,6 @@
                         pass
 
-                if _time == self.lastTimeStamp and _value==self.lastCmd:
+                if _time == self.lastTimeStamp and _value \
+                    == self.lastCmd:
                     continue
                 else:
@@ -1295,15 +1355,15 @@
                 logger.debug('Receive epics command failed')
                 continue
-            
+
             if newCmd == 'CONF':
                 self.getEpicsConfigure()
 
-                self.seekCommand("mantid", "ready")
-                self.seekCommand("pilot", "ready")
+                self.seekCommand('mantid', 'ready')
+                self.seekCommand('pilot', 'ready')
 
                 if int(self.getMantidStatus()[0]) == 3 \
                     and int(self.getPilotStatus()[0]) == 3:
                     self.setEpicsState('READY')
-                    self.myState="ready"
+                    self.myState = 'ready'
                 else:
                     if int(self.getMantidStatus()[0]) != 3:
@@ -1315,9 +1375,9 @@
 
                     self.setEpicsState('ERROR')
-                    self.myState="error"
-                    logger.error('%s failed' % (newCmd))                    
+                    self.myState = 'error'
+                    logger.error('%s failed' % newCmd)
                     break
-
             elif newCmd == 'START':
+
                 # clear drone
 
@@ -1331,16 +1391,16 @@
                 self.resetMonitorCountList()
 
-                self.seekCommand("mantid", "running")
+                self.seekCommand('mantid', 'running')
 
                 self.setStartTime(True)
                 self.setEndTime(False)
 
-                self.seekCommand("pilot", "running")
-                
+                self.seekCommand('pilot', 'running')
+
                 if int(self.getMantidStatus()[0]) == 4 \
                     and int(self.getPilotStatus()[0]) == 4:
                     self.setProtonNeutron()
                     self.setEpicsState('RUNNING')
-                    self.myState="running"
+                    self.myState = 'running'
                 else:
                     if int(self.getMantidStatus()[0]) != 4:
@@ -1351,11 +1411,11 @@
                         pass
                     self.pvStatus.put('ERROR')
-                    self.myState="error"
-                    logger.error('%s failed' % (newCmd))                    
+                    self.myState = 'error'
+                    logger.error('%s failed' % newCmd)
                     break
-
             elif newCmd == 'STOP':
-                self.seekCommand("mantid", "unconfigured")
-                self.seekCommand("pilot", "unconfigured")
+
+                self.seekCommand('mantid', 'unconfigured')
+                self.seekCommand('pilot', 'unconfigured')
 
                 if int(self.getMantidStatus()[0]) == 1 \
@@ -1363,5 +1423,5 @@
                     self.setEndTime(True)
                     self.setEpicsState('INITIALIZED')
-                    self.myState="unconfigured"
+                    self.myState = 'unconfigured'
                 else:
                     if int(self.getMantidStatus()[0]) != 1:
@@ -1373,15 +1433,15 @@
 
                     self.pvStatus.put('ERROR')
-                    logger.error('%s failed' % (newCmd))        
+                    logger.error('%s failed' % newCmd)
                     break
-
             elif newCmd == 'EXIT' or newCmd == 'CANCEL':
-                self.seekCommand("mantid", "unconfigured")
-                self.seekCommand("pilot", "unconfigured")
+
+                self.seekCommand('mantid', 'unconfigured')
+                self.seekCommand('pilot', 'unconfigured')
 
                 if int(self.getMantidStatus()[0]) == 1 \
                     and int(self.getPilotStatus()[0]) == 1:
                     self.setEpicsState('INITIALIZED')
-                    self.myState="unconfigured"
+                    self.myState = 'unconfigured'
                 else:
                     if int(self.getMantidStatus()[0]) != 1:
@@ -1393,8 +1453,8 @@
 
                     self.pvStatus.put('ERROR')
-                    logger.error('%s failed' % (newCmd))    
+                    logger.error('%s failed' % newCmd)
                     break
             else:
-                logger.warning('Invalid command %s' % newCmd)             
+                logger.warning('Invalid command %s' % newCmd)
 
             time.sleep(0.5)
@@ -1402,5 +1462,6 @@
         self.stop.set()
 
-if __name__=="__main__":
+
+if __name__ == '__main__':
     try:
         if sys.argv[1] == 'stop':
@@ -1409,8 +1470,9 @@
         run_this()
 
-    logger.info("===================")
-    logger.info("Welcome to CockPit!")
-    logger.info("        GPPD       ")
-    logger.info("===================")
+    logger.info('===================')
+    logger.info('Welcome to CockPit!')
+    logger.info('        GPPD       ')
+    logger.info('===================')
+
     # "==================="
     # start Redis
@@ -1423,18 +1485,24 @@
         sys.exit()
 
-    #"==================="
+    # "==================="
     # connect Redis
+
     try:
-        #myredis=getRedisServer("10.1.33.141", 9000, 10)
-        myredis=getRedisServer([('10.1.33.141', 9001)], "sanlie;123", 10)
+
+        # myredis=getRedisServer("10.1.33.141", 9000, 10)
+
+        myredis = getRedisServer([('10.1.33.141', 9001)], 'sanlie;123',
+                                 10)
         if myredis.getStatus():
-            redisServer=myredis.getRedisWrite()
-            logger.debug("Redis Connected")
+            redisServer = myredis.getRedisWrite()
+            logger.debug('Redis Connected')
     except:
-        redisServer=None
-        logger.error("Redis not available")
+        redisServer = None
+        logger.error('Redis not available')
         sys.exit()
-    #"==================="
+
+    # "==================="
     # connect Epics
+
     try:
         myepics = getEpicsServer(5)
